from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from StringIO import StringIO
from Products.OrderedObjectManager import cmfoomanager_globals, oomPermission

def install_subskin(self, out, skin_name, globals):
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName) 
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom') +1, skin_name)
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)  

        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)


def install(self):
    out = StringIO()
    
    # Install new skins

    install_subskin(self, out, "oomanager", cmfoomanager_globals)
    print >> out, "Installed skins folder."

    # Add Move-Up/Down to portal_actions
    
    at=getToolByName(self, 'portal_actions')
    nav_props = self.portal_properties.navigation_properties

    if 'move_up' not in [action.id for action in at.listActions()]:
        at.addAction( 'move_up'
                    , 'Move Up'
                    , 'string:move_objs_up:method'
                    , ''
                    , oomPermission
                    , 'folder_buttons' )

        nav_props.manage_addProperty('default.move_objs_up.success','url:folder_contents','string')
        nav_props.manage_addProperty('default.move_objs_up.failure','url:folder_contents','string')

        print >> out, "Added move_up-action."
        
    if 'move_down' not in [action.id for action in at.listActions()]:
        at.addAction( 'move_down'
                    , 'Move Down'
                    , 'string:move_objs_down:method'
                    , ''
                    , oomPermission
                    , 'folder_buttons' )

        nav_props.manage_addProperty('default.move_objs_down.success','url:folder_contents','string')
        nav_props.manage_addProperty('default.move_objs_down.failure','url:folder_contents','string')

        print >> out, "Added move_down-action."
        
    self.portal_properties.navtree_properties.manage_changeProperties(sortCriteria=[])
    print >> out, "Cleared sortCriteria."
        
    # Ok, it's all done...
    
    print >> out, "Successfully installed OrderedObjectManager."
    return out.getvalue()
